clc
%======= Aanpassen handmatig na run 1 ==========%
direction = 'F';
%Rechts naar links = T
%Links naar rechts = F

%======== Run 1 =============%
R1 = 91;
R2 = R1-1;
Q = 1020;
mypath = 'E:\Afstuderen MSc Thesis\Modellen\Quickplot\Gegenereerdedata\';
mypathQ = 'E:\Afstuderen MSc Thesis\Modellen\Quickplot\Gegenereerdedata\Waterwayprofiles\Q1020\';
myfolder2 = 'Referentiebaan\';
myfolder3 = 'waterlevel1020\';
filename2 = [mypath myfolder2 sprintf('Ref%d.xyz',R1)]; 
filename3 = [mypath myfolder3 sprintf('%dwaterlevel.xyz',R1)];  %1020
filename13 = [mypath myfolder3 sprintf('%dwaterlevel.xyz',R2)];  
filename12 = [mypath myfolder2 sprintf('Ref%d.xyz',R2)]; 

%=== Load Raai and Ref data file === %
ReferentiebaanR1 = importdata(filename2);
ReferentiebaanR2 = importdata(filename12);
waterlevelR1 = importdata(filename3);
waterlevelR2 = importdata(filename13);
%=== Raai data ===%
h1 = waterlevelR1.data;
h2 = waterlevelR2.data;
%==== Waterlevel =======%
x1 = h1(:,1); y1 =  h1(:,2); z1 = h1(:,3);
idx1 = find(z1<= -900);
z1(idx1) = NaN;
ZH1 = num2cell(z1(:,:));
x2 = h2(:,1); y2 =  h2(:,2); z2 = h2(:,3);
idx2 = find(z2<= -900);
z2(idx1) = NaN;
ZH2 = num2cell(z2(:,:));

%=====Reference point R1 ==========%
RefR1 = ReferentiebaanR1.data;
RDR1 = num2cell(RefR1(:,:));
RD1idx = cellfun(@(x) isequal(x,0), RDR1(:,3));
RDBaanR1 = RDR1(RD1idx,:);

[a1,b1] = size(RDBaanR1);
if rem(a1,2) == 0 %even%
   NR1 = a1/2; t={2}; M = ((a1/2)+1);
   XAR1 = RDBaanR1(NR1,1); XB = RDBaanR1(M,1);
   YAR1 = RDBaanR1(NR1,2); YB = RDBaanR1(M,2);
   CXR1 = cellfun(@minus,XB,XAR1,'un',0);
   DXR1 = cellfun(@rdivide,CXR1,t,'un',0);
   CYR1 = cellfun(@minus,YB,YAR1,'un',0);
   DYR1 = cellfun(@rdivide,CYR1,t,'un',0);
       XRDR1 = cellfun(@plus,XAR1,DXR1,'un',0);
       YRDR1 = cellfun(@plus,YAR1,DYR1,'un',0);
       ZRDR1 = RDBaanR1(1,3);
elseif  rem(a1,2) == 1 %odd%
    NR1 = ((a1/2)+1/2);
       XRDR1 = RDBaanR1(NR1,1);
       YRDR1 = RDBaanR1(NR1,2);
       ZRDR1 = RDBaanR1(1,3);
else
    info = 'error data...'
end

%==== Reference point for the referentiebaan =====%
%Refpoint = cell2mat([XRD YRD ZRD]);
format longG
RefpointR1 = cell2mat([XRDR1 YRDR1 ZRDR1]);

%=====Reference point R2 ==========%
RefR2 = ReferentiebaanR2.data;
RDR2 = num2cell(RefR2(:,:));
RD2idx = cellfun(@(x) isequal(x,0), RDR2(:,3));
RDBaanR2 = RDR2(RD2idx,:);

[a2,b2] = size(RDBaanR2);
if rem(a2,2) == 0 %even%
   NR2 = a2/2; t={2}; M = ((a2/2)+1);
   XAR2 = RDBaanR2(NR2,1); XB = RDBaanR2(M,1);
   YAR2 = RDBaanR2(NR2,2); YB = RDBaanR2(M,2);
   CXR2 = cellfun(@minus,XB,XAR2,'un',0);
   DXR2 = cellfun(@rdivide,CXR2,t,'un',0);
   CYR2 = cellfun(@minus,YB,YAR2,'un',0);
   DYR2 = cellfun(@rdivide,CYR2,t,'un',0);
       XRDR2 = cellfun(@plus,XAR2,DXR2,'un',0);
       YRDR2 = cellfun(@plus,YAR2,DYR2,'un',0);
       ZRDR2 = RDBaanR2(1,3);
elseif  rem(a2,2) == 1 %odd%
    NR2 = ((a2/2)+1/2);
       XRDR2 = RDBaanR2(NR2,1);
       YRDR2 = RDBaanR2(NR2,2);
       ZRDR2 = RDBaanR2(1,3);
else
    info = 'error data...'
end

%==== Reference point for the referentiebaan =====%
%Refpoint = cell2mat([XRD YRD ZRD]);
format longG
RefpointR2 = cell2mat([XRDR2 YRDR2 ZRDR2]);

%======= Radius ========%
normallijnXR1 = 0.5*(x1(1,1)+x2(1,1));
normallijnYR1 = 0.5*(y1(1,1)+y2(1,1));
normallijnX1 = 0.5*(RefpointR1(:,1)+RefpointR2(:,1));
normallijnY1 = 0.5*(RefpointR1(:,2)+RefpointR2(:,2));
normallijnXR2 = 0.5*(x1(32,1)+x2(32,1));
normallijnYR2 = 0.5*(y1(32,1)+y2(32,1));
Normalpoints =[normallijnXR1 normallijnYR1;normallijnX1 normallijnY1;normallijnXR2 normallijnYR2];

distanceR1Normal =((x1(1,1)-normallijnXR1)^2+(y1(1,1)-normallijnYR1)^2)^0.5;
distanceRef1Normal =((RefpointR1(:,1)-normallijnX1)^2+(RefpointR1(:,2)-normallijnY1)^2)^0.5;
D=distanceRef1Normal + ((RefpointR2(:,1)-normallijnX1)^2+(RefpointR2(:,2)-normallijnY1)^2)^0.5;
distanceR2Normal =((x1(32,1)-normallijnXR2)^2+(y1(32,1)-normallijnYR2)^2)^0.5;
v_R11 = [x1(1,1),y1(1,1),0] - [RefpointR1(1,1),RefpointR1(1,2),0];
v_R12 = [RefpointR2(1,1),RefpointR2(1,2),0] - [RefpointR1(1,1),RefpointR1(1,2),0];
Theta1 = atan2(norm(cross(v_R11, v_R12)), dot(v_R11, v_R12));
DegrTheta1 = Theta1*180/pi;
v_R21 = [x2(1,1),y2(1,1),0] - [RefpointR2(1,1),RefpointR2(1,2),0];
v_R22 = [RefpointR1(1,1),RefpointR1(1,2),0] - [RefpointR2(1,1),RefpointR2(1,2),0];
Theta2 = atan2(norm(cross(v_R21, v_R22)), dot(v_R21, v_R22));
DegrTheta2 = Theta2*180/pi;

%=============== point of intersection of Raai R1 and R2 ===============%
P1 = polyfit(x1,y1,1);
P2 = polyfit(x2,y2,1);
xr = roots(P1-P2);
xr(imag(xr) ~= 0) = [];
yr = polyval(P2,xr);

%========= Radius and direction =============%
radii = ((abs(xr-normallijnX1))^2+(abs(yr-normallijnY1))^2)^0.5;
NP =[normallijnXR1 normallijnYR1;normallijnX1 normallijnY1;normallijnXR2 normallijnYR2; xr yr];
v_dirx = [RefpointR1(1,1),RefpointR1(1,2),0] - [xr,yr,0];
v_diry = [RefpointR2(1,1),RefpointR2(1,2),0] - [xr,yr,0];
Thetadir = atan2(norm(cross(v_dirx, v_diry)), dot(v_dirx, v_diry));
DegrThetadir = Thetadir*180/pi;
    
%========= Figures ==========%

figure(1)
line1=plot(x1,y1,'m');
hold on
line2=plot(x2,y2,'b');
hold on
plot([RefpointR1(:,1) RefpointR2(:,1)],[RefpointR1(:,2) RefpointR2(:,2)],'r','LineWidth',2);
hold on
scatter(RefpointR1(:,1),RefpointR1(:,2),'or');
hold on
scatter(RefpointR2(:,1),RefpointR2(:,2),'dr','filled');
hold on
plot(NP(:,1),NP(:,2),'g');
hold on
plot(xr,yr,'k*');
hold on
viscircles([xr yr],radii,'Color','k','LineWidth',0.5);
set(gca,'FontSize',12);
hold off
legend(['River Waal cross section ' num2str(R1)],['River Waal cross section ' num2str(R2)],['Distance ' num2str(D) ' [m]'],['Reference point ' num2str(R1)]',['Reference point ' num2str(R2)],['Normal line '  num2str(radii) ' [m]'],'Intersection of the crossections','Location','bestoutside')
%title(['River Waal curvature, cross sections ' num2str(R1) ' and ' num2str(R2)]);
xlabel('X-coordinate [RD-coordinate]') 
ylabel('Y-coordinate [RD-coordinate]') 

% %===== create text file with the Radius and the X Y coordinates of the reference points ======%
% %===== Het vaarwegbestand aanmaken met opmaak =======%
% name = sprintf('Bochten%d.txt', R1);
% fileID = fopen([mypathQ name],'wt');
% %======= Add the referencepoints and corresponding RD-coordinates ====%
% fprintf(fileID,'%s\n','');
% fprintf(fileID,'%34s\n','Reference point and Radius');
% fprintf(fileID,'%s\n','');
% fprintf(fileID,'%10s %2s %2s %7s %4s %21s\n','STARTPOINT','X','Y','Radius','F/T','Radian');
% fprintf(fileID,'%s\n','');
% fprintf(fileID,'%3.0f %3.3f %3.3f %3.3f %3.1s %3.6f\n',R1,RefpointR1(1,1),RefpointR1(1,2),radii,direction,Thetadir);
% fprintf(fileID,'%s\n','');
% fprintf(fileID,'%8s %2s %3s\n','ENDPOINT','X','Y');
% fprintf(fileID,'%s\n','');
% fprintf(fileID,'%3.0f %3.3f %3.3f %3.3f %5.2f\n',R2,RefpointR2(1,1),RefpointR2(1,2));
% %============ Add ===============%
% fprintf(fileID,'%s\n','');
% fclose(fileID);
