clc

R = 140;
Q = 900;
mypath = 'E:\Afstuderen MSc Thesis\Modellen\Quickplot\Gegenereerdedata\';
%=== change when running different discharge ========%
mypathQ = 'E:\Afstuderen MSc Thesis\Modellen\Quickplot\Gegenereerdedata\Waterwayprofiles\Q900\';
myfolder1 = 'bedlevelRaaien\';
myfolder2 = 'Referentiebaan\';
%=== change when running different discharge ========%
myfolder3 = 'waterlevel900\';
myfolder4 = 'bakenlijn\';
filename1 = [mypath myfolder1 sprintf('Raai%d.dep.xyz',R)]; 
filename2 = [mypath myfolder2 sprintf('Ref%d.xyz',R)]; 
%=== change when running different discharge ========%
%filename3 = [mypath myfolder3 sprintf('%dwaterlevel.xyz',R)];  %1020
filename3 = [mypath myfolder3 sprintf('%dh.xyz',R)];  %800 en lager
filename4 = [mypath myfolder4 sprintf('%d.xyz',R)]; 

%=== Load Raai and Ref data file === %
bedlevel = importdata(filename1);
Referentiebaan = importdata(filename2);
waterlevel = importdata(filename3);
bakenline = importdata(filename4);

%=== Raai data ===%
Raai = bedlevel.data;
h = waterlevel.data;

%==== Waterlevel =======%
x = h(:,1); y =  h(:,2); z = h(:,3);
idx = find(z<= -900);
z(idx) = NaN;
ZH = num2cell(z(:,:));

%===== Bedlevel ====%
X = Raai(:,1); Y =  Raai(:,2); Z = Raai(:,3);
idX = find(Z<= -900);
Z(idX) = NaN;
ZB = num2cell(Z(:,:));
newNames = {'x_coordinates', 'y_coordinates', 'z_coordinates'};
Raai = splitvars(table(num2cell(Raai)),'Var1','NewVariableNames', newNames);

%====== water - bed = depth ======%
ZDepth = cellfun(@minus,ZH,ZB,'un',0);
Zd = cell2mat(ZDepth);
check = [X Y Zd];
check(any(isnan(check(:,3)), 2), :) = [];

%=== Referentiebaan data ===%
Ref = Referentiebaan.data;
RD = num2cell(Ref(:,:));
RDidx = cellfun(@(x) isequal(x,0), RD(:,3));
RDBaan = RD(RDidx,:);

[a,b] = size(RDBaan);
if rem(a,2) == 0 %even%
   N = a/2; t={2}; M = ((a/2)+1);
   XA = RDBaan(N,1); XB = RDBaan(M,1);
   YA = RDBaan(N,2); YB = RDBaan(M,2);
   CX = cellfun(@minus,XB,XA,'un',0);
   DX = cellfun(@rdivide,CX,t,'un',0);
   CY = cellfun(@minus,YB,YA,'un',0);
   DY = cellfun(@rdivide,CY,t,'un',0);
       XRD = cellfun(@plus,XA,DX,'un',0);
       YRD = cellfun(@plus,YA,DY,'un',0);
       ZRD = RDBaan(1,3);
elseif  rem(a,2) == 1 %odd%
    N = ((a/2)+1/2);
       XRD = RDBaan(N,1);
       YRD = RDBaan(N,2);
       ZRD = RDBaan(1,3);
else
    info = 'error data...'
end

%==== Reference point for the referentiebaan =====%
%Refpoint = cell2mat([XRD YRD ZRD]);
format longG
Refpoint = cell2mat([XRD YRD ZRD]);

%find(ZRD == 0); %referentiebaan data has the value of z = 0%
Ref = splitvars(table(num2cell(Ref)),'Var1','NewVariableNames', newNames);
referencepoint = cell2mat(XRD);

%=== Beacon line data ===%
RefBK = bakenline.data;

%=== Select all beacon line data z = 0 ======================%
BK = num2cell(RefBK(:,:));
BKidx = cellfun(@(x) isequal(x,0), BK(:,3));
BKbaan = BK(BKidx,:);

Beaconline = cell2mat(BKbaan);
X1 = num2cell(X(1,1));
Y1 = num2cell(Y(1,1));
[numRows,numCols] = size(Beaconline);
for bc = 1:numRows
    BCX(bc) = Beaconline(bc,1); BCY(bc) = Beaconline(bc,2);
    BCx(bc) = num2cell(BCX(bc)); BCy(bc) = num2cell(BCY(bc));
    WidthBCX(bc) = cellfun(@minus,BCx(bc),X1,'un',0); 
    WidthBCY(bc) = cellfun(@minus,BCy(bc),Y1,'un',0); 
    WXbc2(bc) = cellfun(@times,WidthBCX(bc),WidthBCX(bc),'un',0);
    WYbc2(bc) = cellfun(@times,WidthBCY(bc),WidthBCY(bc),'un',0);
    Wxybc(bc) = cellfun(@plus,WXbc2(bc),WYbc2(bc),'un',0); 
    WXYbc(bc) = cellfun(@sqrt,Wxybc(bc));   
end

%====== calculate distance form 1 to 32 cell ============%
for w = 1:size(X)
    WX(w) = X(w,1); WY(w) = Y(w,1);
    Wx(w) = num2cell(WX(w)); Wy(w) = num2cell(WY(w));
    WidthX(w) = cellfun(@minus,Wx(w),X1,'un',0); 
    WidthY(w) = cellfun(@minus,Wy(w),Y1,'un',0); 
    WX2(w) = cellfun(@times,WidthX(w),WidthX(w),'un',0);
    WY2(w) = cellfun(@times,WidthY(w),WidthY(w),'un',0);
    Wxy(w) = cellfun(@plus,WX2(w),WY2(w),'un',0); 
    WXY(w) = cellfun(@sqrt,Wxy(w));   
end
WXY = WXY.';
Depth = -1*Zd;

WRef = ((X(1,1)-Refpoint(1,1))^2+(Y(1,1)-Refpoint(1,2))^2)^0.5;
%======= substract distance from point 1 to referenceline ========%
%==== Widht minus Wref ==> Wref is zero =========%
 WReferencepoint = num2cell(WRef);
for ww = 1:size(X)
    W(ww) = num2cell(WXY(ww));
    width(ww) = cellfun(@minus,W(ww),WReferencepoint,'un',0);
end
%=== all 32 data points including NaN data =======%
Width = cell2mat(width.');
WD = [Width Depth];

Bakenline = WXYbc - WRef;
%====== if the beacon line is outside the depth profile =========%
%======= the interpolation should stop at check(length(check)) =============%
Checkleft = check(1,:);
Checkright = check(length(check),:);
CRight = (((X(1,1)-Checkright(1,1))^2+(Y(1,1)-Checkright(1,2))^2)^0.5)-WRef;
CLeft = (((X(1,1)-Checkleft(1,1))^2+(Y(1,1)-Checkleft(1,2))^2)^0.5)-WRef;

%=== Compare X and Y location to the Refpoint =============%
%=== Need one coordinate on both sides of the Refpoint ====%
for k = 1:length(Bakenline)
    BKX(k) = Bakenline(1,k);
if BKX(k) > 0 
    BKI(1,k) = 1;
elseif BKX(k) < 0 
    BKI(1,k) = -1;
else
    BKI(1,k) = 0;
end
end
BKB = [Bakenline(1,:); BKI(1,:)].';   

%=== Calaculate an avarge X and Y value ===================%
%=== for all beaconpoints >  than Refpoint =============%
BKB = num2cell(BKB(:,:));
BKB1idx = cellfun(@(x) isequal(x,1), BKB(:,2));
BKBpos = BKB(BKB1idx,:);
if BKB1idx == 0
         XBKpos = CRight;
         info = 'No Right beacon line in depth profile data...'
else [i j] = size(BKBpos);
        if rem(i,2) == 0 %even%
         K = i/2; t={2}; L = ((i/2)+1);
         XBK = BKBpos(K,1); XBk = BKBpos(L,1);
         XBKp = cellfun(@plus,XBK,XBk,'un',0);
         XBKpos = cellfun(@rdivide,XBKp,t,'un',0);
       elseif  rem(i,2) == 1 %odd%
         K = ((i/2)+1/2);
         XBKpos = BKBpos(K,1);
        else
        info = 'error data...'
        end
end

Bakenlinepos = XBKpos;
%==== Divide the space between the beaconpoint > Refpoint ==========%
%=======in 6 equal parts, to find crossings with the depth ======%

%=== for all beaconpoints < than Refpoint =============%
BKB0idx = cellfun(@(x) isequal(x,-1), BKB(:,2));
BKBneg = BKB(BKB0idx,:);
if BKB0idx == 0
         XBKneg = CLeft;
         info = 'No Left beacon line in depth profile data...'
else [c f] = size(BKBneg);
        if mod(c,2) == 0 %even%
        H = c/2; t={2}; I = ((c/2)+1);
        XBK = BKBneg(H,1); XBk = BKBneg(I,1);
        XBKn = cellfun(@plus,XBK,XBk,'un',0);
        XBKneg = cellfun(@rdivide,XBKn,t,'un',0);
        elseif  mod(c,2) == 1 %odd%
        H = ((c/2)+1/2);
         XBKneg = BKBneg(H,1);
else
    info = 'error data...'
end
end

Bakenlineneg = XBKneg;
Bakenline2 =[Bakenlineneg; Bakenlinepos];
BKleft = cell2mat(Bakenline2(1,1));
BKright = cell2mat(Bakenline2(2,1));
%======== Beacon line distance =========%
%========== Select the smallest of the two ======%
if BKright == CRight
    Widthright = BKright;
elseif BKright > CRight
    Widthright = CRight;
elseif BKright < CRight
    Widthright = BKright;
else
    info = 'error data Right...'
end

if BKleft == CLeft
    Widthleft = BKleft;
elseif -1*BKleft > -1*CLeft
    Widthleft = CLeft;
elseif -1*BKright < -1*CLeft
    Widthleft = BKleft;
else
    info = 'error data Left...'
end
%====== Interpolate between the Ref and Beacon points ============%
%======= Base division in sections om beacon line =======%
%====== to find 5 points on both sides of the Ref line ======%
BKL = -1*Widthleft;
xq = Widthleft:BKL/5:0;
vq1 = interp1(Width,Depth,xq);
xq2 = 0:Widthright/5:Widthright;
vq2 = interp1(Width,Depth,xq2);

%======= River Width at depthline ======================%
%======== Visual check with plot and corrected if needed ========%
depthline1 = -2.0;
xas=WD(:,1); yas=WD(:,2);
zas=find(abs(yas-depthline1)<0.0); ty=yas(zas); tx=xas(zas);

yi=-2.0;
xas(isnan(xas))=0;
indx1=find(xas>0); indx2=find(xas<0);
xas1=xas(indx1); xas2=xas(indx2);
yas(isnan(yas))=0; yas1=yas(indx1);
indy1 = find(yas1==0);
xas1(indy1)=[]; yas1(indy1)=[];
yas2=yas(indx2);
indy2 = find(yas2==0);
xas2(indy2)=[]; yas2(indy2)=[];
coordinat1 = interp1(yas1,xas1,yi)
coordinat1(isnan(coordinat1))=0;
%===========manual correction if needed ===========%
%coordinat1 = 123

coordinat2 = interp1(yas2,xas2,yi)
coordinat2(isnan(coordinat2))=0;
%==========manual correction if needed ============%
%coordinat2 = 106.6

RiverWidth = abs(coordinat1)+abs(coordinat2)
%RiverWidth = 116+81

%========================================================%
%========= Figures ==========%

% %=== 3D plot == %
% figure(2)
% subplot(2,1,1)
% scatter3(X, Y, Z,'b','filled');
% hold on
% scatter3(x,y,z,'k','filled');
% hold on
% scatter3(x,y,Zd,'m','filled');
% hold on
% scatter3(Refpoint(:,1),Refpoint(:,2),Refpoint(:,3),'r');
% hold off
% xlabel('X-coordinate [RD-coordinate]') 
% ylabel('Y-coordinate [RD-coordinate]') 
% zlabel('Height [m]')
% zlim([-10 10]);
% legend('Bed level','water level','Depth','reference line')
% title(['River Waal cross section ' num2str(R) ' discharge ' num2str(Q)]);
% % figure(3)
% % plot(WXY,Zd)

figure(4)
%subplot(2,1,2)
plot(WD(:,1),WD(:,2),'k');
hold on
xline(0,'b','LineWidth',2);
hold on 
yline(0,'--b','LineWidth',1);
hold on
scatter(WD(:,1), WD(:,2),'k');
hold on
scatter(xq,vq1,'*r');
hold on
scatter(xq2,vq2,'*g');
hold on
xline(Widthleft,'r','LineWidth',2);
hold on
xline(Widthright,'g','LineWidth',2);
hold on
d=yline(depthline1,'color','k','LineWidth',2);
%hold on
%yline(depthline2,'color','m','LineWidth',2);
hold on
r=plot(xq,vq1,'-.r','LineWidth',1);
hold on
g=plot(xq2,vq2,'-.g','LineWidth',1);
set(gca,'FontSize',12);
grid on
hold off
legend('Depth contours','Referenceline','Water table','Data points','Linear interpolation, left','Linear interpolation, right','Beacon line left','Beacon line right','Location','northeastoutside');
ylabel('Depth [m]')
xlabel('Distance from reference line [m]')
title(['River Waal cross section ' num2str(R)]);
xqs = -1*xq;
PointsLeft = [xqs; vq1];
PointsRight = [xq2; vq2];

% 
% %===== create text file with waterway layout ======%
% %===== Het vaarwegbestand aanmaken met opmaak =======%
% name = sprintf('Depthprofile%d.txt', R);
% fileID = fopen([mypathQ name],'wt');
% %======= Add the referencepoints and corresponding RD-coordinates ====%
% fprintf(fileID,'%s\n','');
% fprintf(fileID,'%34s\n','C. Vaarwegprofiel tot rechteroever');
% fprintf(fileID,'%s\n','');
% fprintf(fileID,'%4s %2s %8s %5s %5s %5s %5s %5s %5s %5s %5s %5s\n','PUNT','D0','BR(1)','DR(1)','BR(2)','DR(2)','BR(3)','DR(3)','BR(4)','DR(4)','BR(5)','DR(5)');
% fprintf(fileID,'%s\n','');
% %======= Add the right side of the waterway in 5 points ====%
% fprintf(fileID,'%3.0f  %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %5.2f\n',R,PointsRight(2,1),PointsRight(1,6),PointsRight(2,6),PointsRight(1,5),PointsRight(2,5),PointsRight(1,4),PointsRight(2,4),PointsRight(1,3),PointsRight(2,3),PointsRight(1,2),PointsRight(2,2));
% fprintf(fileID,'%s\n','');
% fprintf(fileID,'%s\n','');
% fprintf(fileID,'%33s\n','D. Vaarwegprofiel tot linkeroever');
% fprintf(fileID,'%s\n','');
% fprintf(fileID,'%4s %11s %5s %5s %5s %5s %5s %5s %5s %5s %5s\n','PUNT','BL(1)','DL(1)','BL(2)','DL(2)','BL(3)','DL(3)','BL(4)','DL(4)','BL(5)','DL(5)');
% fprintf(fileID,'%s\n','');
% %======= Add the left side of the waterway in 5 points ====%
% fprintf(fileID,'%3.0f  %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %3.3f %5.2f\n',R,PointsLeft(1,1),PointsLeft(2,1),PointsLeft(1,2),PointsLeft(2,2),PointsLeft(1,3),PointsLeft(2,3),PointsLeft(1,4),PointsLeft(2,4),PointsLeft(1,5),PointsLeft(2,5));
% 
% 
% %============ Add ===============%
% fprintf(fileID,'%s\n','');
% fclose(fileID);

%===== create text file with waterway layout ======%
name = sprintf('Width%d.txt', R);
fileID = fopen([mypathQ name],'wt');
fprintf(fileID,'%s\n','');
fprintf(fileID,'%16s %12s\n','Profile number','River width');
fprintf(fileID,'%3.0f  %3.3f\n',R,RiverWidth);
fprintf(fileID,'%s\n','');
fclose(fileID);
